(function($, doc) {
    $.site = 'http://api.woyaocha.cn';
    
    $.debugging = true;
    
    // 基础类
    $.mtk = {
        'open': function(url, id, ext) {
            $.openWindow({
                url: url,
                id: id,
                style: {},
                extras: ext,
                show: {
                    autoShow: true,
                    aniShow: "slide-in-right",
                    duration: 100
                },
                waiting: {
                    autoShow: true,
                    title: "加载中...",
                    options: {}
                }
            });
        },

        'get': function(url, param, type, callback) {
            $.ajax(url, {
                data: param,
                dataType: 'json', //服务器返回json格式数据
                type: 'post', //HTTP请求类型
                timeout: 10000, //超时时间设置为10秒；
                success: function(data) {
                    if(data.status==1){
                        callback(data);
                    }
                },
                error: function(xhr, type, errorThrown) {
                    if($.debugging){
                        $.alert(url+'无响应');
                    }else{
                        $.alert('服务器连接超时，请稍后再试');
                    }
                }
            });
        }
    };
   
    // 广告类代码
    $.adv = {
        'index': function(param, type, callback) {
            $.mtk.get($.site + '/?c=Adv&a=detail', param, type, callback);
        }
    };
    
    // 数据类代码
    $.loan = {
        // 贷款列表
        'list': function(page, param, callback) {
            $.mtk.get($.site + '/?c=Product&a=index&p='+page, param, 'json', callback);
        },
        'recome':function(page, param, callback){
            $.mtk.get($.site + '/?c=Product&a=recome&p='+page, param, 'json', callback);
        }
    };
    
    // 工具类
    $.tools = {
        // 随机生成贷款数据
        'loan':function(num){
            var data={},tel=new Array('130','138','139','158','170','150');
            data['info']=new Array();
            for(i=0;i<=num;i++){
                var arr = {};
                arr['tel'] = tel[Math.floor(Math.random()*tel.length)];
                arr['phone'] = Math.floor(Math.random()*9)+''+Math.floor(Math.random()*9)+''+Math.floor(Math.random()*9)+''+Math.floor(Math.random()*9);
                arr['num'] = 1000+Math.floor(Math.random()*5000);
                data['info'][i] = arr;
            }
            return data;
        }
    };
})(mui, document);
