(function($, doc) {
    //禁止横屏
    $.plusReady(function () { 
        plus.screen.lockOrientation("portrait-primary"); 
    }); 
    // 基础控制器
    $.mtk = {
        'details': function(link, type) { // 获取资讯或应用详情
            // 打开资讯详情页
            if(type == 0) {
                var url = '/webview/news/detail.html',
                    id = 'news_details';
            } else if(type == 1) {
                var url = '/webview/game/detail.html',
                    id = 'game_details';
            } else if(type == 2) {
                var url = '/webview/gift/detail.html',
                    id = 'gift_details';
            } else if(type == 3) {
                var url = '/webview/special/detail.html',
                    id = 'special_details';
            }

            $.mtk.open(url, id, {
                'url': link
            });

        },

        'content': function(url, callback) { // 获取资讯或应用详情内容

            $.ajax(url, {
                data: {},
                dataType: 'html', //服务器返回json格式数据
                type: 'get', //HTTP请求类型
                timeout: 10000, //超时时间设置为10秒；

                beforeSend: function() {
                    plus.nativeUI.showWaiting('加载中...');
                },
                complete: function() {
                    plus.nativeUI.closeWaiting();
                },
                success: function(data) {
                    callback(data);
                },
                error: function(xhr, type, errorThrown) {
                    mui.alert('服务器连接超时，请稍后再试');
                }
            });
        },

        'open': function(url, id, ext) { // 打开新窗口
            $.openWindow({
                url: url,
                id: id,
                style: {},
                extras: ext,
                show: {
                    autoShow: true,
                    aniShow: "slide-in-right",
                    duration: 100
                },
                waiting: {
                    autoShow: true,
                    title: "加载中...",
                    options: {}
                }
            });
        },

        'list': function(page, param, callback, type) {
            if(type == 0) {
                url = site + '/?c=news&a=index&p=' + page;
            } else if(type == 1) {
                url = site + '/?c=game&a=index&p=' + page;
            } else if(type == 2) {
                url = site + '/?c=package&a=index&p=' + page;
            } else if(type == 3) {
                url = site + '/?c=zt&a=index&p=' + page;
            } else if(type == 4) {
                url = site + '/?c=member&a=game&p=' + page;
            } else if(type == 5) {
                url = site + '/?c=member&a=package&p=' + page;
            } else if(type == 6) {
                url = site + '/?c=search&a=game&p=' + page;
            } else if(type == 7) {
                url = site + '/?c=search&a=news&p=' + page;
            } else if(type == 8) {
                url = site + '/?c=search&a=package&p=' + page;
            } else if(type == 9) {
                url = site + '/?c=news&a=wenda&p=' + page;
            }
            $.ajax(url, {
                data: param,
                dataType: 'json', //服务器返回json格式数据
                type: 'post', //HTTP请求类型
                timeout: 10000, //超时时间设置为10秒；
                success: function(data) {
                    callback(data);
                },
                error: function(xhr, type, errorThrown) {
                    $.alert('服务器连接超时，请稍后再试');
                }
            });
        },

        // 剪切板效果
        'clip': {
            'set': function(txt) {
                if(txt) {
                    if($.os.android) {
                        var Context = plus.android.importClass("android.content.Context");
                        var main = plus.android.runtimeMainActivity();
                        var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
                        plus.android.invoke(clip, "setText", txt);
                    } else {
                        var UIPasteboard = plus.ios.importClass("UIPasteboard");
                        var generalPasteboard = UIPasteboard.generalPasteboard();
                        // 设置/获取文本内容:
                        generalPasteboard.setValueforPasteboardType(txt, "public.utf8-plain-text");
                    }
                }
            },
            'get': function() {
                if($.os.android) {
                    var Context = plus.android.importClass("android.content.Context");
                    var main = plus.android.runtimeMainActivity();
                    var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
                    return plus.android.invoke(clip, "getText");
                } else {
                    var UIPasteboard = plus.ios.importClass("UIPasteboard");
                    var generalPasteboard = UIPasteboard.generalPasteboard();
                    return generalPasteboard.valueForPasteboardType("public.utf8-plain-text");
                }
            }
        }
    };

    // 资讯特效
    $.news = {
        'details': function(url) { // 打开资讯详情页
            $.mtk.details(url, 0);
        },

        'content': function(url) { // 获取资讯内容
            if($.os.ios) {
                url = url + '?os=2';
            } else {
                url = url + '?os=1';
            }
            $.mtk.content(url, function(data) {

                doc.querySelector('body').innerHTML = data + doc.querySelector('body').innerHTML;

                // $.news.top();

                $('.mui-scroll-wrapper').scroll({
                    deceleration: 0.0005, //阻尼系数,系数越小滑动越灵敏
                    bounce: true //是否启用回弹
                });

                if($(".gamelist").length) {
                    $(".gamelist").on("tap", "a", function() {

                        $.game.details(this.getAttribute('href'));

                    });
                }

            });
        },

        'top': function() { // 资讯详情关联应用下载
            var b = doc.querySelector('.news_hd').offsetHeight, // 顶部原始高度
                c = false;
            // 内容中下载应用效果
            window.onscroll = function(e) {
                var a = document.documentElement.scrollTop || document.body.scrollTop; // 顶部距离

                if(a >= b) {
                    // todo 解决加入内容fixed时，其他内容向上弹入
                    if(!c) {
                        doc.querySelector('.gamelist').classList.add('fix');
                        c = !c;
                    }
                } else {
                    if(c == true) {
                        doc.querySelector('.gamelist').classList.remove('fix');
                        c = false;
                    }
                }
            }
        },

        'list': function(page, param, callback) {
            $.mtk.list(page, param, callback, 0);
        },

        'wenda': function(page, param, callback) {
            $.mtk.list(page, param, callback, 9);
        }
    };

    // 广告特效
//  $.adv = {
//      'get': function(param, type, callback) {
//          $.ajax(site + '/?c=Adv&a=index', {
//              data: param,
//              dataType: type, //服务器返回json格式数据
//              type: 'post', //HTTP请求类型
//              timeout: 10000, //超时时间设置为10秒；
//              success: function(data) {
//                  callback(data);
//              },
//              error: function(xhr, type, errorThrown) {
//                  $.alert('服务器连接超时，请稍后再试');
//              }
//          });
//      }
//  };

    // 游戏特效
    $.game = {
        'details': function(url) { // 打开应用详情页
            $.mtk.details(url, 1);
        },

        'content': function(url) { // 获取应用内容
            if($.os.ios) {
                url = url + '?os=2';
            } else {
                url = url + '?os=1';
            }
            $.mtk.content(url, function(data) {

                doc.querySelector('body').innerHTML = data + doc.querySelector('body').innerHTML;

                $('.mui-slider').slider();

                // 游戏下载
                $.game.down();

                // 收藏游戏
                $.game.follow();

                // 打开资讯详情
                $('#item3').on('tap', '#newslist a', function() {
                    $.news.details(this.getAttribute('href'));
                });

                // 打开礼包详情
                $("#item2").on("tap", "#giftlist a", function() {
                    $.gift.details(this.getAttribute('href'));

                });

                // 页面拉取动态效果
                $('.mui-scroll-wrapper').scroll({
                    deceleration: 0.0005, //阻尼系数,系数越小滑动越灵敏
                    bounce: true //是否启用回弹
                });

                $('#item1').imageLazyload({
                    placeholder: '../../img/thumb.png'
                });
                $('#item2').imageLazyload();
                $('#item3').imageLazyload();
            });

        },

        // 游戏列表
        'list': function(page, param, callback) {
            $.mtk.list(page, param, callback, 1);
        },

        // 收藏游戏
        'follow': function() {

            $('.btnwrap').on('tap', '.collect', function() {

                var self = this;
                $.ajax({
                    type: "post",
                    url: site + "/?c=Game&a=follow",
                    async: true,
                    data: {
                        id: this.getAttribute('data-id'),
                        type: this.getAttribute('data-follow')
                    },
                    datType: 'json',
                    timeout: 10000, //超时时间设置为10秒
                    beforeSend: function() {
                        // 禁止重复登录
                        plus.nativeUI.showWaiting('收藏中...');
                    },
                    complete: function() {
                        //plus.nativeUI.closeWaiting();
                    },
                    success: function(res) {
                        plus.nativeUI.closeWaiting();
                        if(res.status == 200) {
                            $.toast(res.msg);
                            if(self.getAttribute('data-follow') == 1) {
                                self.innerHTML = '<img src="../../img/collect.png"/>';
                                self.setAttribute('data-follow', 0);
                            } else {
                                self.innerHTML = '<img src="../../img/nocollect.png"/>';
                                self.setAttribute('data-follow', 1);
                            }
                        } else if(res.status == 300) {
                            $.toast(res.msg);
                        } else if(res.status == 400) {
                            $.toast('请先登录');

                            $.openWindow({
                                url: '/webview/login/login.html',
                                id: 'login_login'
                            });
                        }
                    },
                    error: function(xhr, type, errorThrown) {
                        plus.nativeUI.closeWaiting();
                        $.alert('服务器连接超时，请稍后再试');
                    }
                });
            });

        },

        // 游戏下载
        'down': function() {
            var id = doc.getElementById('app_down').getAttribute('game-id'),
                icon = doc.getElementById('game_icon').getAttribute('src'),
                name = doc.getElementById('game_name').innerHTML;
            if(id > 0) {
                var down = $.download();
                down.init({
                    'game_id': id,
                    'status': true,
                    'create': function() {
                        $('.btnwrap .downloadwrap').on('tap', '#app_down', function() {
                            if(!down.options.disabled) {
                                down.options.disabled = true;
                                if($.os.ios) {
                                    window.location.href = doc.getElementById('app_down').getAttribute("ios_link");
                                    
                                } else {
                                    down.options.task = plus.downloader.createDownload(doc.getElementById('app_down').getAttribute("android_link"), {
                                        app_id: id,
                                        app_icon: icon,
                                        app_name: name
                                    });
                                }
                                down.start();
                            }
                        });
                    },

                    'bind': function() {
                        $('.btnwrap .downloadwrap').on('tap', '#app_load a', function() {
                            down.bind();
                        });
                    }, // 下载任务启动暂停事件

                    'start': function() {
                        doc.getElementById('app_down').style.display = 'none';
                        doc.getElementById('app_load').style.display = 'block';
                        doc.getElementById('app_load').children[0].style.width = '0%';
                        doc.getElementById('app_load').children[0].children[0].innerHTML = '暂停(0%)';
                    },

                    'process': function(task, status) {
                        if(task.totalSize) {
                            var num = Math.floor((task.downloadedSize / task.totalSize) * 100);
                        } else {
                            var num = 0;
                        }
                        doc.getElementById('app_load').children[0].style.width = num + '%';
                        if(status == 0) {
                            doc.getElementById('app_load').children[0].children[0].innerHTML = '暂停(' + num + '%)';
                        } else {
                            doc.getElementById('app_load').children[0].children[0].innerHTML = '继续(' + num + '%)';
                        }
                    },

                    'end': function() {

                        doc.getElementById('app_down').style.display = 'block';
                        doc.getElementById('app_load').style.display = 'none';
                        doc.getElementById('app_load').children[0].style.width = '0%';
                        doc.getElementById('app_load').children[0].children[0].innerHTML = '暂停(0%)';
                        plus.webview.currentWebview().reload();
                    }
                });
            }
        }
    };

    // 礼包特效
    $.gift = {
        'details': function(url) { // 打开应用详情页
            $.mtk.details(url, 2);
        },

        'content': function(url) { // 获取应用内容
            $.mtk.content(url, function(data) {

                doc.querySelector('body').innerHTML = data + doc.querySelector('body').innerHTML;

                $('.mui-scroll-wrapper').scroll({
                    deceleration: 0.0005, //阻尼系数,系数越小滑动越灵敏
                    bounce: true //是否启用回弹
                });

                // 下载app
                $('.btnwrap').on('tap', '.down', function() {
                    $.game.details(site + '/game/' + this.getAttribute('data-game'));
                });

                // 收藏游戏
                $('.btnwrap').on('tap', '.collect', function() {
                    var self = this;

                    $.getJSONP(passport + '/package.html', {
                        'package_id': this.getAttribute('data-id')
                    }, function(data) {
                        if(data.status == 1) {

                            var btnArray = ['确定', '复制'];
                            $.confirm(decodeURI(data.info), '信息提示', btnArray, function(e) {
                                if(e.index == 1) {
                                    $.mtk.clip.set(data.info);
                                }
                            });

                        } else if(data.status == -1) {
                            $.toast('领取失败');
                        } else if(data.status == 0) {
                            $.toast('请先登录');
                            $.openWindow({
                                url: '/webview/login/login.html',
                                id: 'login_login'
                            });
                        }
                    });
                });

                //礼包icon跳转gamedetial
                $(".giftgame .gifticon").on("tap", "a", function() {
                    $.game.details(this.getAttribute('href'));
                });
            });

        },

        'list': function(page, param, callback) {
            $.mtk.list(page, param, callback, 2);
        }
    };

    // 专题特效
    $.special = {
        'details': function(url) { // 打开应用详情页
            $.mtk.details(url, 3);
        },

        'content': function(url) { // 获取应用内容
            $.mtk.content(url, function(data) {

                doc.querySelector('body').innerHTML = data + doc.querySelector('body').innerHTML;

                $('.gamelist').on('tap', 'li a', function() {
                    $.game.details(this.getAttribute('href'));
                });

                $('.mui-scroll-wrapper').scroll({
                    deceleration: 0.0005, //阻尼系数,系数越小滑动越灵敏
                    bounce: true //是否启用回弹
                });
                
                $('.gamelist').imageLazyload({
                    placeholder: '../../img/icon.png',
                    autoDestroy: false
                });
            });

        },

        'list': function(page, param, callback) {
            $.mtk.list(page, param, callback, 3);
        }
    };

    // 关注
    $.fav = {
        'game': function(page, param, callback) {
            $.mtk.list(page, param, callback, 4);
        },
        'remove': function(url) {
            $.ajax(url, {
                data: {},
                dataType: 'json', //服务器返回json格式数据
                type: 'post', //HTTP请求类型
                timeout: 10000, //超时时间设置为10秒；
                success: function(data) {
                    if(data.status == 200) {
                        $.toast('取消关注成功');
                        plus.webview.currentWebview().reload();
                    } else if(data.status == 400) {
                        $.mtk.open('/webview/login/login.html', 'login_index', {});
                    }
                },
                error: function(xhr, type, errorThrown) {
                    $.alert('服务器连接超时，请稍后再试');
                }
            });
            return false;
        },
        'gift': function(page, param, callback) {
            $.mtk.list(page, param, callback, 5);
        }
    };

    // 头像设置
    $.avatar = {
        'set': function(type, param) {
            if(type == 0) {
                // 拍照上传图片
                var c = plus.camera.getCamera(),
                    s = '';
                c.captureImage(function(e) {
                    plus.io.resolveLocalFileSystemURL(e, function(entry) {
                        s = entry.toLocalURL() + "?version=" + new Date().getTime();
                        param.path = s;
                        $.mtk.open('/webview/my/avatar.html', 'my_avatar', param);
                    }, function(e) {
                        $.toast('获取照片失败');
                    });
                }, function(s) {
                    $.toast('拍照失败');
                }, {
                    filename: "_doc/head.jpg"
                });

            } else if(type == 1) {
                plus.gallery.pick(function(a) {
                    plus.io.resolveLocalFileSystemURL(a, function(entry) {
                        plus.io.resolveLocalFileSystemURL("_doc/", function(root) {
                            root.getFile("head.jpg", {}, function(file) {
                                //文件已存在
                                file.remove(function() {
                                    entry.copyTo(root, 'head.jpg', function(e) {

                                            param.path = e.fullPath + "?version=" + new Date().getTime();
                                            $.mtk.open('/webview/my/avatar.html', 'my_avatar', param);
                                        },
                                        function(e) {
                                            $.toast('获取照片失败');
                                        });
                                }, function() {

                                });
                            }, function() {
                                //文件不存在
                                entry.copyTo(root, 'head.jpg', function(e) {
                                        param.path = e.fullPath + "?version=" + new Date().getTime();
                                        $.mtk.open('/webview/my/avatar.html', 'my_avatar', param);
                                    },
                                    function(e) {
                                        $.toast('获取照片失败');
                                    });
                            });
                        }, function(e) {
                            $.toast('获取照片失败');
                        })
                    }, function(e) {
                        $.toast('获取照片错误');
                    });
                }, function(a) {}, {
                    filter: "image"
                });
            }
        }
    };

    // 搜索
    $.search = {
        // 最近搜索
        'last': function(callback) {
            callback = callback || function(res) {};
            data = $.search.get();
            callback(data);
        },

        // 游戏搜索
        'game': function(page, param, callback) {
            $.mtk.list(page, param, callback, 6);
        },

        // 资讯搜索
        'news': function(page, param, callback) {
            $.mtk.list(page, param, callback, 7);
        },

        // 礼包搜索
        'gift': function(page, param, callback) {
            $.mtk.list(page, param, callback, 8);
        },

        // 更新最近搜索
        'set': function(key) {
            if(key) {
                arr = $.search.get(),
                    data = new Array();

                data.unshift(key);
                // 去重
                $.each(arr, function(index, item) {
                    if(item != key && data.length <= 5) {
                        data.push(item);
                    }
                });

                localStorage.setItem('user-search', JSON.stringify(data));
            }
        },

        // 获取最近搜索
        'get': function() {

            // 自动登录设置
            var arr = localStorage.getItem('user-search');
            if(arr) {
                arr = JSON.parse(arr);
                return arr;
            } else {
                return new Array();
            }
        },

        'init': function() {

            if($('.mui-bar-nav .search').length > 0) {
                $('.mui-bar-nav').on('tap', '.search', function() {
                    $.mtk.open('/webview/search/index.html', 'search_index', {});
                });
            }
        }
    };

    $.search.init();

})(mui, document);