/**
 * 用户中心设置脚本
 * @param {Object} $
 * @param {Object} doc
 * @param {Object} win
 */
(function($, doc, win) {
    // 初始化
    $.ready(function() {

        // 设置当前用户信息
        $.user.info(function(data) {
            if(data.status == 200) {
                if(data.data.pic) {
                    doc.querySelector('#user_info #head-img').setAttribute('src', data.data.pic);
                    doc.querySelector('#account #head-img').setAttribute('src', data.data.pic);
                }
                doc.querySelector('#user_info #head-nickname').innerHTML = 'Hello ' + decodeURI(data.data.nickname) + '<p class="mui-ellipsis">账号:' + decodeURI(data.data.name) + '</p>';
                doc.querySelector('#account #head-name').innerHTML = decodeURI(data.data.name);
                doc.querySelector('#account #head-nickname').innerHTML = decodeURI(data.data.nickname);
                doc.querySelector('#account #head-contact').innerHTML = data.data.contact;
                doc.querySelector('#account #head-tel').innerHTML = data.data.tel;
                doc.querySelector('#account #head-mail').innerHTML = data.data.mail;

            } else if(data.status == 400) {
                $.mtk.open('/webview/login/login.html', 'login_index', {});
            }
        });

    });

    // 用户头像修改
    $('#account').on('tap', '#avatar', function(e) {
        if($.os.plus) {
            var a = [{
                title: "拍照"
            }, {
                title: "从手机相册选择"
            }];
            plus.nativeUI.actionSheet({
                title: "修改头像",
                cancel: "取消",
                buttons: a
            }, function(b) {
                switch(b.index) {
                    case 0:
                        break;
                    case 1:
                        $.avatar.set(0, {
                            callback: {
                                id: 'change_avatar'
                            }
                        });
                        break;
                    case 2:

                        $.avatar.set(1, {
                            callback: {
                                id: 'change_avatar'
                            }
                        });
                        break;
                    default:
                        break
                }
            })
        }
    });

    // 增加图片修改监听
    win.addEventListener('change_avatar', function(event) {
        $('.head-img').each(function() {
            this.src = event.detail.path;
        });

        plus.webview.getWebviewById("my").reload();
    });

    // 用户昵称修改
    $('#account').on('tap', '#nickname', function(e) {
        e.detail.gesture.preventDefault();
        $.prompt(' ', this.querySelector('#head-nickname').innerHTML, '修改昵称', ['取消', '确定'], function(r) {
            if(r.index == 1) {
                $.user.change(0, r.value, function(data) {
                    if(data.status == 200) {
                        plus.webview.currentWebview().reload();
                        plus.webview.getWebviewById('my').reload();
                    } else if(data.status == 400) {
                        $.mtk.open('/webview/login/login.html', 'login_index', {});
                    } else {
                        $.toast(data.msg);
                    }
                });
            }
        });
    });

    // 用户QQ修改
    $('#account').on('tap', '#contact', function(e) {
        e.detail.gesture.preventDefault();
        $.prompt(' ', this.querySelector('#head-contact').innerHTML, '修改QQ', ['取消', '确定'], function(r) {
            if(r.index == 1) {
                $.user.change(1, r.value, function(data) {
                    if(data.status == 200) {
                        plus.webview.currentWebview().reload();
                        plus.webview.getWebviewById('my').reload();
                    } else if(data.status == 400) {
                        $.mtk.open('/webview/login/login.html', 'login_index', {});
                    } else {
                        $.toast(data.msg);
                    }
                });
            }
        });
    });

    // 用户手机修改
    $('#account').on('tap', '#tel', function(e) {
        e.detail.gesture.preventDefault();
        $.prompt(' ', this.querySelector('#head-tel').innerHTML, '修改手机', ['取消', '确定'], function(r) {
            if(r.index == 1) {
                $.user.change(2, r.value, function(data) {
                    if(data.status == 200) {
                        plus.webview.currentWebview().reload();
                        plus.webview.getWebviewById('my').reload();
                    } else if(data.status == 400) {
                        $.mtk.open('/webview/login/login.html', 'login_index', {});
                    } else {
                        $.toast(data.msg);
                    }
                });
            }
        });
    });

    // app检查更新
    doc.getElementById('update').addEventListener('tap', function() {
        $.getJSON(upurl, {
            "appid": plus.runtime.appid,
            "version": plus.runtime.version,
            "imei": plus.device.imei,
            "uuid": plus.device.uuid,
            "os": $.os.ios ? 1 : 0,
            "doajax": 1
        }, function(res) {
            if(res.status == 2) {
                plus.ui.confirm('已检测到新版，是否更新', function(i) {
                    if(0 == i.index) {

                        if($.os.ios) {
                            plus.runtime.openURL(res.down);
                        } else {
                            var dtask = plus.downloader.createDownload(res.down, {}, function(d, status) {
                                if(status == 200) {
                                    var path = d.filename; //下载apk
                                    plus.runtime.install(path); // 自动安装apk文件
                                } else {
                                    $.toast('版本更新失败');
                                }
                            });
                            dtask.start();
                        }

                    }
                }, '提示', ["立即更新", "取消"]);

            } else if(res.status == 1) {
                $.toast('恭喜您，已是最新版本~');
            }else{
                $.toast(res.msg);
            }

        });
    });

    // 意见反馈
    $('.feedbtn').on('tap', '#feedback-btn', function() {
        if(doc.getElementById('contact').value && doc.getElementById('question').value) {
            $.ajax({
                type: "post",
                url: site + "/?c=Feedback&a=add",
                async: true,
                data: {
                    'type': 2,
                    'contact': doc.getElementById('contact').value,
                    'content': doc.getElementById('question').value
                },
                datType: 'json',
                timeout: 10000, //超时时间设置为10秒
                beforeSend: function() {
                    plus.nativeUI.showWaiting('提交中...');
                },
                complete: function() {
                    //plus.nativeUI.closeWaiting();
                },
                success: function(res) {
                    plus.nativeUI.closeWaiting();
                    $.alert('感谢你的宝贵建议');
                },
                error: function(xhr, type, errorThrown) {
                    plus.nativeUI.closeWaiting();
                    $.alert('服务器连接超时，请稍后再试');
                }
            });
        } else {
            $.alert('请填写完整反馈信息');
        }
    });

})(mui, document, window);