/**
 * App用户
 */
(function($, doc, win) {

    $.user = {

        setting: {
            'auth': false,
            'info': false //登录状态
        },

        login: function(data, callback) {
            calback = callback || function(res) {};
            
            // 数据验证
            if(data.name.length < 4) {
                $.toast('账户最短为4个字符');
                return false;
            } else if(data.name.length > 16) {
                $.toast('账户最长为16个字符');
                return false;
            }

            if(data.pass.length < 6) {
                $.toast('密码最短为6个字符');
                return false;
            }

            if(data.code.length != 4) {
                $.toast('请输入有效验证码');
                return false;
            }

            // 检查登录或注册状态
            if($.user.setting.auth == false) {
                $.ajax({
                    type: "post",
                    url: passport + "/login.html",
                    async: true,
                    data: data,
                    datType: 'json',
                    timeout: 10000, //超时时间设置为10秒
                    beforeSend: function() {
                        // 禁止重复登录
                        $.user.setting.auth = true;
                        plus.nativeUI.showWaiting('登陆中...');
                    },
                    complete: function() {
                        //plus.nativeUI.closeWaiting();
                    },
                    success: function(res) {
                        $.user.setting.auth = false;
                        plus.nativeUI.closeWaiting();
                        callback(res);
                    },
                    error: function(xhr, type, errorThrown) {
                        plus.nativeUI.closeWaiting();
                        $.alert('服务器连接超时，请稍后再试');
                    }
                });
            }
        },

        logout: function() {
            if($.user.setting.auth == false) {
                $.ajax({
                    type: "post",
                    url: passport + "/logout.html",
                    async: true,
                    data: {},
                    datType: 'json',
                    timeout: 10000, //超时时间设置为10秒
                    beforeSend: function() {
                        // 禁止重复登录
                        $.user.setting.auth = true;
                    },
                    complete: function() {
                        //plus.nativeUI.closeWaiting();
                    },
                    success: function(res) {
                        $.toast('退出成功');
                        $.user.setting.auth = false;
                        plus.webview.getWebviewById('my').reload();
                        $.back();
                    },
                    error: function(xhr, type, errorThrown) {
                        $.alert('服务器连接超时，请稍后再试');
                    }
                });
            } else {
                $.toast('退出失败');
            }
        },

        // 自动登录
        auto: function(val) {
            if(val) {
                localStorage.setItem('user-info', JSON.stringify(val));
            } else {
                // 自动登录设置
                var h = localStorage.getItem('user-info');
                if(h) {
                    h = JSON.parse(h);
                    doc.getElementById('name').value = h.name;
                    doc.getElementById('pass').value = h.pass;
                }

            }
        },

        // 用户信息
        info: function(callback) {
            if($.user.setting.info == false) {
                $.ajax($.site + '/?c=Member&a=info', {
                    data: {},
                    dataType: 'json', //服务器返回json格式数据
                    type: 'post', //HTTP请求类型
                    timeout: 10000, //超时时间设置为10秒；
                    success: function(data) {
                        callback(data);
                    },
                    error: function(xhr, type, errorThrown) {
                        $.alert('服务器连接超时，请稍后再试');
                    }
                });
            }
        },

        // 修改用户信息
        change: function(type, val, callback) {
            var param = {};
            param.type = type;
            if(param.type == 0) {
                param.nickname = val;
            } else if(param.type == 1) {
                param.contact = val;
            } else if(param.type == 2) {
                param.tel = val;
            }

            $.ajax(site + '/?c=member&a=change', {
                data: param,
                dataType: 'json', //服务器返回json格式数据
                type: 'post', //HTTP请求类型
                timeout: 10000, //超时时间设置为10秒；
                success: function(data) {
                    callback(data);
                },
                error: function(xhr, type, errorThrown) {
                    $.alert('服务器连接超时，请稍后再试');
                }
            });
        },

        // 用户注册
        register: function(data, callback) {

            calback = callback || function(res) {};

            // 数据验证
            if(data.name.length < 4) {
                $.toast('账户最短为4个字符');
                return false;
            } else if(data.name.length > 16) {
                $.toast('账户最长为16个字符');
                return false;
            }

            if(data.pass.length < 6) {
                $.toast('密码最短为6个字符');
                return false;
            }

            if(data.repass.length < 6) {
                $.toast('确认密码最短为6个字符');
                return false;
            } else if(data.pass.length != data.repass.length) {
                $.toast('两次密码不一致');
                return false;
            }

            if(data.mail.length <= 0) {
                $.toast('请输入邮箱');
                return false;
            } else if(!(data.mail.length > 3 && data.mail.indexOf('@') > -1)) {
                $.toast('邮箱格式错误');
                return false;
            }

            if(data.code.length != 4) {
                $.toast('请输入有效验证码');
                return false;
            }

            // 检查登录或注册状态
            if($.user.setting.auth == false) {
                $.ajax({
                    type: "post",
                    url: passport + "/reg.html",
                    async: true,
                    data: data,
                    datType: 'json',
                    timeout: 10000, //超时时间设置为10秒
                    beforeSend: function() {
                        // 禁止重复登录
                        $.user.setting.auth = true;
                        plus.nativeUI.showWaiting('注册中...');
                    },
                    complete: function() {
                        //plus.nativeUI.closeWaiting();
                    },
                    success: function(res) {
                        $.user.setting.auth = false;
                        plus.nativeUI.closeWaiting();
                        callback(res);
                    },
                    error: function(xhr, type, errorThrown) {
                        plus.nativeUI.closeWaiting();
                        $.alert('服务器连接超时，请稍后再试');
                    }
                });
            }
        },

        // 忘记密码
        forget: function(data, callback) {

            calback = callback || function(res) {};

            if(data.mail.length <= 0) {
                $.toast('请输入邮箱');
                return false;
            } else if(!(data.mail.length > 3 && data.mail.indexOf('@') > -1)) {
                $.toast('邮箱格式错误');
                return false;
            }

            if(data.code.length != 4) {
                $.toast('请输入有效验证码');
                return false;
            }

            // 检查登录或注册状态
            if($.user.setting.auth == false) {
                $.ajax({
                    type: "post",
                    url: passport + "/forget.html",
                    async: true,
                    data: data,
                    datType: 'json',
                    timeout: 10000, //超时时间设置为10秒
                    beforeSend: function() {
                        // 禁止重复登录
                        $.user.setting.auth = true;
                        plus.nativeUI.showWaiting('提交中...');
                    },
                    complete: function() {
                        //plus.nativeUI.closeWaiting();
                    },
                    success: function(res) {
                        $.user.setting.auth = false;
                        plus.nativeUI.closeWaiting();
                        callback(res);
                    },
                    error: function(xhr, type, errorThrown) {
                        plus.nativeUI.closeWaiting();
                        $.alert('服务器连接超时，请稍后再试');
                    }
                });
            }
        }
    };
    
})(mui, document, window);