/**
 * App用户
 */
(function($, doc, win) {

    $.member = {
        
        logining:false,
        
        info: {
            'id':0,
            'name':'',
            'avatar':'',
            'real_name':'',
            'card_id':''
        }, // 记录登录信息

        // 获取用户状态
        update:function(callback){
            calback = callback || function(res) {};
            if(!this.info.id){
                $.ajax($.site + '/?c=Member&a=info', {
                    data: {},
                    dataType: 'json', //服务器返回json格式数据
                    type: 'post', //HTTP请求类型
                    timeout: 10000, //超时时间设置为10秒；
                    success: function(data) {
                        if(data.status==1){
                            $.extend($.member.info,data.data);
                        }
                        
                        callback(data);
                    },
                    error: function(xhr, type, errorThrown) {
                        if($.debugging){
                            $.alert($.site + '/?c=Member&a=info请求失败');
                        }else{
                            $.alert('服务器连接超时，请稍后再试');
                        }
                    }
                });
                
            }else{
                callback(this.info);
            }
        },

        // 自动登录
        auto: function(val) {
            if(val) {
                localStorage.setItem('user-info', JSON.stringify(val));
            } else {
                // 自动登录设置
                var h = localStorage.getItem('user-info');
                if(h) {
                    h = JSON.parse(h);
                    doc.getElementById('name').value = h.name;
                    doc.getElementById('pass').value = h.pass;
                }

            }
        },
        
        // 用户登录·
        login: function(data, callback) {
            calback = callback || function(res) {};
            
            // 数据验证
            if(data.name.length < 4) {
                $.toast('账户最短为4个字符');
                return false;
            } else if(data.name.length > 16) {
                $.toast('账户最长为16个字符');
                return false;
            }

            if(data.pass.length < 6) {
                $.toast('密码最短为6个字符');
                return false;
            }

            // 检查登录或注册状态
            if(this.info.length){
                callback(this.info);
            }else{
                if(!this.logining){
                    $.ajax({
                        type: "post",
                        url: $.site + "/?c=Member&a=login",
                        async: true,
                        data: data,
                        datType: 'json',
                        timeout: 10000, //超时时间设置为10秒
                        beforeSend: function() {
                            // 禁止重复登录
                            $.member.logining = true;
                            plus.nativeUI.showWaiting('登录中...');
                        },
                        complete: function() {
                            //plus.nativeUI.closeWaiting();
                        },
                        success: function(res) {
                            $.member.logining = false;
                            plus.nativeUI.closeWaiting();
                            callback(res);
                        },
                        error: function(xhr, type, errorThrown) {
                            plus.nativeUI.closeWaiting();
                            $.alert('服务器连接超时，请稍后再试');
                        }
                    });
                }else{
                    $.member.logining = false;
                    plus.nativeUI.closeWaiting();
                    $.alert('登录中，请稍后再试');
                }
            }
        },

        // 用户注册
        register: function(data, callback) {

            calback = callback || function(res) {};

            // 数据验证
            if(data.name.length < 11) {
                $.toast('账户最短为11个字符');
                return false;
            } else if(data.name.length > 16) {
                $.toast('账户最长为16个字符');
                return false;
            }

            if(data.pass.length < 6) {
                $.toast('密码最短为6个字符');
                return false;
            }

            if(data.code.length != 6) {
                $.toast('请输入有效验证码');
                return false;
            }

            // 检查登录或注册状态
            if(this.info.id){
                callback(this.info);
            }else{
                if(!this.logining){
                    $.ajax({
                        type: "post",
                        url: $.site + "/?c=Member&a=reg",
                        async: true,
                        data: data,
                        datType: 'json',
                        timeout: 10000, //超时时间设置为10秒
                        beforeSend: function() {
                            // 禁止重复登录
                            $.member.logining = true;
                            plus.nativeUI.showWaiting('注册中...');
                        },
                        complete: function() {
                            //plus.nativeUI.closeWaiting();
                        },
                        success: function(res) {
                            $.member.logining = false;
                            plus.nativeUI.closeWaiting();
                            callback(res);
                        },
                        error: function(xhr, type, errorThrown) {
                            $.member.logining = false;
                            plus.nativeUI.closeWaiting();
                            $.alert('服务器连接超时，请稍后再试');
                        }
                    });
                }
            }
        },

        // 忘记密码
        forget: function(data, callback) {

            calback = callback || function(res) {};

            // 数据验证
            if(data.name.length < 4) {
                $.toast('账户最短为4个字符');
                return false;
            } else if(data.name.length > 16) {
                $.toast('账户最长为16个字符');
                return false;
            }

            if(data.pass.length < 6) {
                $.toast('密码最短为6个字符');
                return false;
            }

            if(data.code.length != 4) {
                $.toast('请输入有效验证码');
                return false;
            }


            // 检查登录或注册状态
            if(!this.logining){
                $.ajax({
                    type: "post",
                    url: passport + "/?c=Member&a=forget",
                    async: true,
                    data: data,
                    datType: 'json',
                    timeout: 10000, //超时时间设置为10秒
                    beforeSend: function() {
                        // 禁止重复登录
                        $.member.logining = true;
                        plus.nativeUI.showWaiting('提交中...');
                    },
                    complete: function() {
                        //plus.nativeUI.closeWaiting();
                    },
                    success: function(res) {
                        $.member.logining = false;
                        plus.nativeUI.closeWaiting();
                        callback(res);
                    },
                    error: function(xhr, type, errorThrown) {
                        plus.nativeUI.closeWaiting();
                        $.alert('服务器连接超时，请稍后再试');
                    }
                });
            }
        },
        
        logout: function() {

            $.ajax({
                type: "post",
                url: $.site + "/?c=Member&a=logout",
                async: true,
                data: {},
                datType: 'json',
                timeout: 10000, //超时时间设置为10秒
                beforeSend: function() {

                },
                complete: function() {
                    //plus.nativeUI.closeWaiting();
                },
                success: function() {
                    $.toast('退出成功');
                    plus.webview.getWebviewById('my').reload();
                    $.back();
                },
                error: function(xhr, type, errorThrown) {
                    if($.debugging){
                        $.alert($.site + "/?c=Member&a=logout连接失败");
                    }else{
                        $.alert('服务器连接超时，请稍后再试');
                    }
                }
            });
        },
        
        load: function(callback){

            calback = callback || function(res) {};
            if(!this.info.id){
                $.ajax($.site + '/?c=Member&a=load', {
                    data: {},
                    dataType: 'json', //服务器返回json格式数据
                    type: 'post', //HTTP请求类型
                    timeout: 10000, //超时时间设置为10秒；
                    success: function(data) {
                        if(data.status==1){
                            $.extend($.member.info,data.data.index);
                            $.extend($.member.info,data.data.detail);
                        }
                        
                        callback(data);
                    },
                    error: function(xhr, type, errorThrown) {
                        if($.debugging){
                            $.alert($.site + '/?c=Member&a=load请求失败');
                        }else{
                            $.alert('服务器连接超时，请稍后再试');
                        }
                    }
                });
            }else{
                callback(this.info);
            }
        },

        // 修改用户信息
        change: function(type, val, callback) {
            var param = {};
            param.type = type;
            if(param.type == 0) {
                param.real_name = val;
            } else if(param.type == 1) {
                param.card_id = val;
            }

            $.ajax($.site + '/?c=Member&a=change', {
                data: param,
                dataType: 'json', //服务器返回json格式数据
                type: 'post', //HTTP请求类型
                timeout: 10000, //超时时间设置为10秒；
                success: function(data) {
                    callback(data);
                },
                error: function(xhr, type, errorThrown) {
                    $.alert('服务器连接超时，请稍后再试');
                }
            });
        }
    
    };
    
})(mui, document, window)
