/**
 * 用户中心设置脚本
 * @param {Object} $
 * @param {Object} doc
 * @param {Object} win
 */
(function($, doc, win) {
    // 初始化
    $.ready(function() {
        $.member.load(function(res){
            if(res.status==0){
                $.mtk.open('/webview/login/login.html', 'login_index', {});
            }else{
                var user = $.member.info;
                if(user.avatar) {
                    doc.querySelector('#account #head-img').setAttribute('src', user.avatar);
                }
                doc.querySelector('#account #head-name').innerHTML = decodeURI(user.name);
                if(user.real_name){
                    doc.querySelector('#account #head-realname').innerHTML = decodeURI(user.real_name);
                }
                doc.querySelector('#account #head-cardid').innerHTML = user.card_id;
            }
        });
        
        // 修改姓名
        $('#account').on('tap', '#realname', function(e) {
            e.detail.gesture.preventDefault();
            $.prompt(' ', this.querySelector('#head-realname').innerHTML, '修改姓名', ['取消', '确定'], function(r) {
                if(r.index == 1) {
                    $.member.change(0, r.value, function(data) {
                        if(data.status == 1) {
                            plus.webview.currentWebview().reload();
                            plus.webview.getWebviewById('my').reload();
                        } else {
                            $.toast(data.msg);
                        }
                    });
                }
            });
        });

        // 修改身份证
        $('#account').on('tap', '#cardid', function(e) {
            e.detail.gesture.preventDefault();
            $.prompt(' ', this.querySelector('#head-cardid').innerHTML, '修改身份证', ['取消', '确定'], function(r) {
                if(r.index == 1) {
                    $.member.change(1, r.value, function(data) {
                        if(data.status == 1) {
                            plus.webview.currentWebview().reload();
                            plus.webview.getWebviewById('my').reload();
                        } else {
                            $.toast(data.msg);
                        }
                    });
                }
            });
        });
        
        // app检查更新
        doc.getElementById('update').addEventListener('tap', function() {
            $.getJSON($.site+'/?c=Index&a=update', {
                "appid": plus.runtime.appid,
                "version": plus.runtime.version,
                "imei": plus.device.imei,
                "uuid": plus.device.uuid,
                "os": $.os.ios ? 1 : 0
            }, function(res) {
                if(res.status == 2) {
                    plus.ui.confirm('已检测到新版，是否更新', function(i) {
                        if(0 == i.index) {
    
                            if($.os.ios) {
                                plus.runtime.openURL(res.down);
                            } else {
                                var dtask = plus.downloader.createDownload(res.down, {}, function(d, status) {
                                    if(status == 200) {
                                        var path = d.filename; //下载apk
                                        plus.runtime.install(path); // 自动安装apk文件
                                    } else {
                                        $.toast('版本更新失败');
                                    }
                                });
                                dtask.start();
                            }
    
                        }
                    }, '提示', ["立即更新", "取消"]);
    
                } else if(res.status == 1) {
                    $.toast('恭喜您，已是最新版本~');
                }else{
                    $.toast(res.msg);
                }
    
            });
        });

    });
/*

    // 意见反馈
    $('.feedbtn').on('tap', '#feedback-btn', function() {
        if(doc.getElementById('contact').value && doc.getElementById('question').value) {
            $.ajax({
                type: "post",
                url: site + "/?c=Feedback&a=add",
                async: true,
                data: {
                    'type': 2,
                    'contact': doc.getElementById('contact').value,
                    'content': doc.getElementById('question').value
                },
                datType: 'json',
                timeout: 10000, //超时时间设置为10秒
                beforeSend: function() {
                    plus.nativeUI.showWaiting('提交中...');
                },
                complete: function() {
                    //plus.nativeUI.closeWaiting();
                },
                success: function(res) {
                    plus.nativeUI.closeWaiting();
                    $.alert('感谢你的宝贵建议');
                },
                error: function(xhr, type, errorThrown) {
                    plus.nativeUI.closeWaiting();
                    $.alert('服务器连接超时，请稍后再试');
                }
            });
        } else {
            $.alert('请填写完整反馈信息');
        }
    });
*/
})(mui, document, window);